import java.util.*;

public class ContactTracing_AN {
  public static void main(String[] args) {
    Scanner s = new Scanner(System.in);
    int N = s.nextInt();
    int K = s.nextInt();
    int C = s.nextInt();

    int[][][] adj = new int[K + 1][N + 1][C + 1];
    for (int i = 0; i < C; i++) {
      int a = s.nextInt(), b = s.nextInt(), d = s.nextInt();
      adj[d][a][++adj[d][a][0]] = b;
      adj[d][b][++adj[d][b][0]] = a;
    }

    int[] lastSafe = new int[N + 1];
    for (int d = 1; d <= K; d++) {
      for (int a = 1; a <= N; a++) {
        if (adj[d][a][0] > 0) lastSafe[a] = d - 1;
      }
    }

    Set<Integer> poss = new TreeSet<>();

    for (int p0 = 1; p0 <= N; p0++) {
      if (lastSafe[p0] > 0) continue;
      boolean[][] infected = new boolean[K+1][N+1];
      infected[0][p0] = true;
      for (int d = 1; d <= K; d++) {
        for (int a = 1; a <= N; a++) {
          if (lastSafe[a] > d) continue;
          for (int bi = 1; bi <= adj[d][a][0]; bi++) {
            int b = adj[d][a][bi];
            if (infected[d-1][b]) {
              infected[d][a] = true;
              if (d == K) poss.add(a);
            }
          }
        }
      }
    }

    System.out.println(poss.size());
    for (int i : poss) System.out.println(i);
  }
}
